package baza4;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import javax.swing.*;
import java.util.*;

class Osoba implements Serializable
 { String nazwisko;
   float srednia;
   String uwagi;
    
   public  void Nadaj_nazwisko(String lan)
    { nazwisko=lan;}
   public String Podaj_nazwisko()
    { return nazwisko;}
   public  void Nadaj_uwagi(String lan)
    { uwagi=lan;}
   public String Podaj_uwagi()
     { return uwagi;}
   public  void Nadaj_srednia(float srednia_)
    { srednia=srednia_;} 
  public float Podaj_srednia()
     {return srednia;}

  public String toString()
   {String napis="";
    napis+="Nazwisko: "+nazwisko;
    napis+=" srednia: "+srednia;
    napis+=" uwagi: "+uwagi;
    return napis;
   }
   
  public boolean Szukaj(String s) 
   { return nazwisko.equals(s);
   }
 }  

class  Tablica implements Serializable
{    
  Osoba Dane[]=null; 
  int ile=0;  
  
  public boolean Pusta()
    {
      return ile==0;
    }
  
  public boolean Pelna()
    {
      return ile==Dane.length;
    }
 public int Podaj_ile()
   {
     return ile;
   }
 
  public void Wykonaj_tablice(int N)
   {
      ile=0;
      Dane=new Osoba[N]; //utworzenie tablicy
   }
  
  public void Wstaw (String nazwisko_, float srednia, String uwagi_)
   {
      Osoba dana=new Osoba();
      dana.Nadaj_nazwisko(nazwisko_);
      dana.Nadaj_srednia(srednia);
      dana.Nadaj_uwagi(uwagi_);
      Dane[ile]=dana;
      ile++; 
   }
  
   public Osoba Wyszukaj(String s)
    {
      for (int i=0; i<ile;i++)
       if (Dane[i].Szukaj(s))
        return   Dane[i];
      return null;
    }
   
   public String toString()
   {
       String s="";
       for (int i=0; i<ile; i++)
         s+=Dane[i].toString()+"\n";
       return s;
   }
}

public class Baza4
{ 
  protected Tablica tablica=new Tablica();
  
  public void Wyswietl()
     {
      if (tablica.Pusta())//jesli tablica istnieje, to mozna wyswietlac
           JOptionPane.showMessageDialog(null,"Brak danych"); 
      else 
        JOptionPane.showMessageDialog(null,tablica.toString()); 
    }
  
  public void Wypelnij()
    { String S;
      S=JOptionPane.showInputDialog(null,"Podaj rozmiar tablicy");
      int N=Integer.parseInt(S);
      tablica.Wykonaj_tablice(N); //utworzenie tablicy
      String S1,S2,S3;
      while(!tablica.Pelna()) //jeśli tablica jes zapełniona, tak jest równe false
       { 
         S1 = JOptionPane.showInputDialog(null, "Podaj nazwisko"); 
         S2 = JOptionPane.showInputDialog(null, "Podaj srednia");
         S3 =JOptionPane.showInputDialog(null, "Podaj uwagi");
         tablica.Wstaw(S1, Float.parseFloat(S2), S3);//dopisanie danych na końcu danych
       }  
    }
 
   public void Wyszukaj()
   {
     if (tablica.Pusta())//jesli tablica istnieje, to mozna wyszukiwac
           JOptionPane.showMessageDialog(null,"Brak danych"); 
     else
     {
      String S = JOptionPane.showInputDialog(null,"Podaj nazwisko");
      Object osoba=tablica.Wyszukaj(S);   
      if(osoba!=null)
       JOptionPane.showMessageDialog(null,osoba.toString()); 
     }
   }
   
   public void Zapisz_do_pliku_obiektow()
   {   if (tablica.Pusta())//jesli tablica istnieje, to mozna zapisac do pliku
           JOptionPane.showMessageDialog(null,"Brak danych"); 
      else 
      try
       { FileOutputStream plik = new FileOutputStream ("baza3.obj");
         ObjectOutputStream  strumienobiektow = new ObjectOutputStream (plik);
         strumienobiektow.writeObject(tablica);
         strumienobiektow.close();
        } catch (IOException e)
           { JOptionPane.showMessageDialog(null,
                 "Blad zapisu pliku obiektow" +e); 
           } 
   }  
   
   public void Odczytaj_plik_obiektow_na_ekran()
    {   try
         { FileInputStream plik = new FileInputStream ("baza3.obj");
           ObjectInputStream  strumienobiektow = new ObjectInputStream (plik);
            Tablica tablica_=(Tablica)strumienobiektow.readObject();
            JOptionPane.showMessageDialog(null,tablica_.toString());
            strumienobiektow.close();
          }catch (Exception e)
                { JOptionPane.showMessageDialog(null,
                   "Blad odczytu pliku obiektow "+e);
                 }
    }
    
    public void Odczytaj_plik_obiektow_do_tablicy()
    {   try
          { FileInputStream plik = new FileInputStream ("baza3.obj");
      	    ObjectInputStream  strumienobiektow = new ObjectInputStream (plik);
            tablica=(Tablica)strumienobiektow.readObject();
            strumienobiektow.close();           
           } catch (Exception e)
                { JOptionPane.showMessageDialog(null,
                   "Blad odczytu pliku obiektow "+e);
                }
    }
   
   static public  void main(String args[])
   {  Baza4 baza1=new Baza4(); //referencja do tablicy, kt�ra jest tworzona w opcji 1
      char ch;
      String s;
      do
      { s=JOptionPane.showInputDialog(null, "Progam nie jest zabezpieczony przed\n" +
                "złym formatem danych\n i naciskaniem Cancel w okienkach dialogowych\n"+
                "Podaj wybor"
        +"\n1 - Wypelnij tablice,"
        +"\n2 - Wyswietl dane osob"
        +"\n3 - Wyszukaj osobe i wyswietl jej dane"
        +"\n4 - Zapisz plik obiektów"
        +"\n5 - Odczytaj plik obiektow i wyswietl na ekranie"
        +"\n6 - Odczytaj plik obiektow i zapisz do tablicy"
        +"\nk - Koniec programu");
      ch = s.charAt(0);  //pobranie opcji
      switch(ch)
       {case '1' : baza1.Wypelnij();
                   break;
        case '2' : baza1.Wyswietl();        
                   break;
        case '3' : baza1.Wyszukaj(); 
                   break;  
        case '4' : baza1.Zapisz_do_pliku_obiektow();
                   break;
        case '5' : baza1.Odczytaj_plik_obiektow_na_ekran();
                   break;
        case '6' : baza1.Odczytaj_plik_obiektow_do_tablicy();
                   break;
        case 'k' : JOptionPane.showMessageDialog(null, "Koniec programu");
                   break;
        default  : JOptionPane.showMessageDialog(null,"Zla opcja");       
    }
 }while (ch != 'k') ;
 System.exit(0); 
  }
}

